/****************** CONVERT.C ********************/
/*                                               */
/* Public Domain - (W) 1996 by Henning Stcklein */
/*                     DB5SH @ DB0RBS.#BW.DEU.EU */
/*                                               */
/* Verwendung d. Programmes fr den persnlichen */
/* Gebrauch ist zulssig, solange keine kommerzi-*/
/* ellen Interessen verfolgt werden. Es besteht  */
/* keine Haftung fr Schden jeglicher Art, die  */
/* durch die Benutzung des Programmes entstehen  */
/* sollten. Verwendung und und Modifikation des  */
/* Quelltextes ist zulssig, es mu jedoch eine  */
/* Angabe der ursprnglichen Herkunft erfolgen.  */
/*                                               */
/* Der Quelltext ist angepat auf IBM C/Set 2.1  */
/*                                               */
/*     Compilieren/Linken mit:  ICC CONVERT.C    */
/*************************************************/

#define INCL_DOSMEMMGR
#define INCL_DOS

#define BTY_NONE	0	/* fr Boxlist-Mailboxtyp */
#define BTY_BAYBOX	1
#define BTY_DIEBOX	2
#define BTY_FBB		3
#define BTY_OTHERBOX	4
#define BTY_RMNCDIGI	5
#define BTY_NETROMDIGI	6
#define BTY_DXCLUSTER	7
#define BTY_OTHERDIGI	8

#include <fcntl.h>
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <process.h>
#include <stddef.h>
#include <ctype.h>
#include <os2.h>

#define	  Version "30.7.1996"

/* Globale Variablen */
CHAR		InFileName[80], OutFileName[80],
		Zeile[500] ;

USHORT		cnt, i, WaitCnt, Code ;

ULONG		Action, rc ;

FILE		*InFile, *OutFile ;

HFILE		ConHandle ;

/* Digi-Datensatz */
char		Call[10] ;
SHORT		LineType ;
SHORT		BoxType ;
char		TypeStr[10] ;
char		Status[10] ;
char		Date[10] ;
char		Soft[10] ;
char		Hard[10] ;
char		QRG[10] ;
char		Baud[10] ;
char		Sysop[10] ;
char		Locator[10] ;
char		QTH[50] ;
char		Info[50] ;

char		*Token ;

/************ QPRINTF ****************/
/* Ausgabe nach CON (auch ohne CRLF) */
/* ConHandle wird global bernommen. */
/*************************************/
void qprintf (char *Text)
{
  ULONG Anz ;

  DosWrite (ConHandle, Text, strlen(Text), &Anz) ;
  return ;
}

/******* MAIN *********/
/*   Hauptprogramm    */
/**********************/
void main (int argc, char *argv[])
{
   /* Einschaltmeldung ausgeben */
   printf ("*** Convert/2  Version " Version "  by H.Stcklein DB5SH\n") ;

   /* Handle zum Bildschirm ffnen */
   rc = DosOpen ("CON",
	&ConHandle,
	&Action,
	0L,			/* ulFilesize */
	0L,			/* ulFileAttribute */
	0x01,
	OPEN_ACCESS_READONLY |
	OPEN_SHARE_DENYREADWRITE,
	0L) ;			/* pEABuf */

   /* Kommandozeilenparameter parsen */
   if (argc > 1)
      strcpy (InFileName, argv[1]) ;
   else
   {
      qprintf ("Quelldatei: ") ;
      scanf ("%12s", InFileName) ;
   }

   /* Falls Hilfe gewnscht: Meldung ausgeben und fertig */
   if (!strcmp(InFileName, "?") || !strcmp(InFileName, "h"))
   {
      printf ("Public Domain by Henning Stcklein DB5SH @ DB0RBS.#BW.DEU.EU\n\n") ;
      printf ("Convert/2 ist ein Zusatzprogramm zu FlexPacket/2 fr OS/2.\n") ;
      printf ("Es wandelt HAMMAP-kompatible Stationsdateien (ASCII) in eine\n") ;
      printf ("FP/2-Mailboxdatenbank um, in der alle Stationen aus OE, F, DL\n") ;
      printf ("und HB enthalten sind.\n\n") ;
      printf ("Aufruf: CONVERT <infile> <outfile>\n\n") ;
      return ;
   }

   if (argc > 2)
      strcpy (OutFileName, argv[2]) ;
   else
   {
      qprintf ("Zieldatei : ") ;
      scanf ("%12s", OutFileName) ;
   }

   /* Das Quellfile ffnen */
   InFile = fopen (InFileName, "r") ;

   /* Das Zielfile anlegen */
   OutFile = fopen (OutFileName, "w") ;
 
   while (!feof (InFile))
   {
      fgets (Zeile, 200, InFile) ;		/* eine Zeile einlesen */

      Token = strtok (Zeile, ",") ;
      strncpy (Call, Token, 10) ;

      if ((Call[0] == 'D') ||
          (Call[0] == 'F') ||
	  ((Call[0] == 'H') && (Call[1] == 'B')) ||
	  ((Call[0] == 'O') && (Call[1] == 'E')))
      {
	Token = strtok (NULL, ",") ;
	LineType = atoi (Token) ;

	Token = strtok (NULL, ",") ;
	strncpy (Status, Token, 3) ;

	Token = strtok (NULL, ",") ;
	strncpy (Date, Token, 5) ;

	Token = strtok (NULL, ",") ;
	strncpy (TypeStr, Token, 3) ;

	Token = strtok (NULL, ",") ;
	strncpy (Soft, Token, 3) ;

	BoxType = 0 ;
	if (!strncmp (TypeStr, "WX", 2)) BoxType = 12 ;
	if (!strncmp (TypeStr, "TI", 2)) BoxType = 15 ;
	if (!strncmp (TypeStr, "DX", 2)) BoxType = 11 ;

	if (BoxType == 0)
	{
	  if (!strncmp (Soft, "FN", 2)) BoxType = 6 ;
	  if (!strncmp (Soft, "TH", 2)) BoxType = 10 ;
	  if (!strncmp (Soft, "TO", 2)) BoxType = 9 ;
	  if (!strncmp (Soft, "TN", 2)) BoxType = 8 ;
	  if (!strncmp (Soft, "KN", 2)) BoxType = 17 ;
	  if (!strncmp (Soft, "WA", 2)) BoxType = 14 ;
	  if (!strncmp (Soft, "OE", 2)) BoxType = 16 ;
	  if (!strncmp (Soft, "BC", 2)) BoxType = 13 ;
	  if (!strncmp (Soft, "BM", 2)) BoxType = 1 ;
	  if (!strncmp (Soft, "DW", 2)) BoxType = 13 ;
	  if (!strncmp (Soft, "SN", 2)) BoxType = 13 ;
	  if (!strncmp (Soft, "G8", 2)) BoxType = 13 ;
	  if (!strncmp (Soft, "DB", 2)) BoxType = 2 ;
	  if (!strncmp (Soft, "DP", 2)) BoxType = 3 ;
	  if (!strncmp (Soft, "FB", 2)) BoxType = 4 ;
	}

	Token = strtok (NULL, ",") ;
	strncpy (Hard, Token, 3) ;

	Token = strtok (NULL, ",") ;
	strncpy (QRG, Token, 10) ;
	if (atoi(QRG) < 0)
	   strcpy (QRG, "") ;

	Token = strtok (NULL, ",") ;
	strncpy (Baud, Token, 10) ;

	Token = strtok (NULL, ",") ;
	strncpy (Sysop, Token, 10) ;
	/* Sysop von angehngten Leerzeichen befreien */
	for (i=strlen(Sysop); i; i--)
	  if (Sysop[i] == ' ') Sysop[i] = '\0' ;

	Token = strtok (NULL, ",") ;
	strncpy (Locator, Token, 10) ;

	Token = strtok (NULL, ",") ;
	strncpy (QTH, Token, 40) ;

	Token = strtok (NULL, ",") ;
	strncpy (Info, Token, 50) ;
	if (Info[strlen(Info)-1] == '\n')	/* CR abtrennen */
	   Info[strlen(Info)-1] = '\0' ;

	/* Call von angehngten Leerzeichen befreien */
	for (i=strlen(Call); i; i--)
	  if (Call[i] == ' ') Call[i] = '\0' ;

	printf ("%s\t", Call) ;

	/* Nur Haupteintrge in die Datenbank bernehmen */
	if (LineType == 0)
	{
	  fprintf (OutFile, "=%s\n", Call) ;
	  fprintf (OutFile, "!%d\n", BoxType) ;	/* Type */
	  fprintf (OutFile, "<%d\n", 0) ;		/* Pref Chan */
	  fprintf (OutFile, "*%s\n", QTH) ;		/* Ort */
	  fprintf (OutFile, "&%s\n", Locator) ;
	  fprintf (OutFile, "+\n") ;			/* Connect via */
	  fprintf (OutFile, "-%s\n", QRG) ;
	  fprintf (OutFile, ">[%s] %s\n", Sysop, Info) ;
	  fprintf (OutFile, ":\n") ;
	  fprintf (OutFile, ";\n") ;
	}
      }
   }

   /* Alles gelaufen, ergo die Deckel wieder drauf */
   fclose (InFile) ;
   fclose (OutFile) ;
   DosClose (ConHandle) ;

   return ;
}
